;-------------------------------
; Space Invaders Test ROM
; Documented and transfered to TASM
; By Timothy Shiels
; 08/2008
; www.outerworldarcade.com
;-------------------------------
			.area MAIN (REL)

			.globl ramtest
			.globl print, clrscrn ,drawchar, curs_x, curs_y, printword, ptrnscrn
			.globl drawlabel, sndtest
			.globl test_roms
			.globl test_shifter


TopStack .equ 0x2400
;--------
; Set-up
;--------
            xra a
            out 0x03

            jmp ramtest
endramtest::
            lxi sp,TopStack    ; set stack pointer to 0x2400

            out 0x06

            call ptrnscrn
 
            lxi d,txtRamOK  ;
            lxi h,curs_x    ; print "RAMS => OK"
            mvi m,4
            lxi h,curs_y
            mvi m,4
            call print

            call test_roms

            call drawlabel
            call sndtest
            call sndtest
            
            call test_shifter

end:        jmp end

;            lxi     h,0x2C81     ; print ">CHECK INPORT"
;            lxi     h,0x3301     ; print ">CHECK SOUND"
;            call    print2      ; print "PORT 1  01234567"
;            call    print2      ; print "PORT 1  01234567" (will be port 2)
;            call    drawchar    ; print "2" FOR PORT2


; 0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F  G  H  I  J  K
;00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F 10 11 12 13 14
;
; L  M  N  O  P  Q  R  S  T  U  V  W  X  Y  Z  <  >    =  *  -
;15 16 17 18 19 1A 1B 1C 1D 1E 1F 20 21 22 23 24 25 26 27 28 29
txtRamOK:
.byte 0x1B, 0x0A, 0x16, 0x26, 0x27, 0x26, 0x18, 0x14, 0xFF; "RAM = OK"

.byte 0x52, 0x4F, 0x4D, 0x20, 0x75, 0x6E, 0x64, 0x65
.byte 0x72, 0x20, 0x47, 0x50, 0x4C, 0x20, 0x62, 0x79
.byte 0x20, 0x46, 0x72, 0x65, 0x64, 0x65, 0x72, 0x69
.byte 0x63, 0x20, 0x52, 0x4F, 0x44, 0x4F, 0x2F, 0x62
.byte 0x61, 0x73, 0x65, 0x64, 0x20, 0x6F, 0x6E, 0x20
.byte 0x54, 0x69, 0x6D, 0x6F, 0x74, 0x68, 0x79, 0x27
.byte 0x73, 0x20, 0x77, 0x6F, 0x72, 0x6B, 0x28, 0x6F
.byte 0x75, 0x74, 0x65, 0x72, 0x77, 0x6F, 0x72, 0x6C
.byte 0x64, 0x61, 0x72, 0x63, 0x61, 0x64, 0x65, 0x2E
.byte 0x63, 0x6F, 0x6D, 0x29, 0x2F, 0x49, 0x4E, 0x20
.byte 0x4D, 0x45, 0x4D, 0x4F, 0x52, 0x59, 0x20, 0x4F
.byte 0x46, 0x20, 0x4C, 0x45, 0x4F, 0x4E, 0x20, 0x42
.byte 0x4F, 0x52, 0x52, 0x45  

fonttest:
.byte 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
.byte 16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31
.byte 32,33,34,35,36,37,38,39,40,41,42,0xff
          
            .area _DATA (DSEG)


                                                 